import java.sql.*;

// Script 9.5 'AddInvoice2.java'

public class AddInvoice2 {

	public static void main(String args[]) throws Exception {

		// Initialize variables.
		Connection con = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		int affected = 0;
		int id = 0;
				
		try {
		
			// Connect to MySQL.
			String url = "jdbc:mysql:///accounting";
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			con = DriverManager.getConnection(url, "username", "password");
						
			// Prepare the query.
			stmt = con.prepareStatement("INSERT INTO invoices (client_id, invoice_amount, invoice_description) VALUES (?, ?, ?)");
			
			// Assign values.
			stmt.setInt(1, Integer.parseInt(args[0]));
			stmt.setFloat(2, Float.parseFloat(args[1]));
			stmt.setString(3, args[2]);
			
			// Execute the query.
			affected = stmt.executeUpdate();
			
			// Confirm that the insert worked.
			if (affected == 1) {
				rs = stmt.getGeneratedKeys();
				rs.next();
				id = rs.getInt(1);
				System.out.println("Invoice number " + id + " has been created!");
			} else {
				System.out.println("The invoice could not be added to the database!");
			}
		}
		
		// Catch exceptions.
		catch (SQLException e) {
			System.out.println("Problem: " + e.toString());
		}
		
		// Clean up.
		finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					// Do nothing with exception.
				}
				rs = null;
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					// Do nothing with exception.
				}
				stmt = null;
			}
			if (con != null) {
				try {
					con.close();
				} catch (SQLException e) {
					// Do nothing with exception.
				}
			}
		}
		
	} // End of main().
	
} // End of class AddInvoice2.
